--- old/usr/src/lib/libipadm/common/ipadm_ipmgmt.h	Mon Nov 14 16:21:17 2016
+++ new/usr/src/lib/libipadm/common/ipadm_ipmgmt.h	Mon Nov 14 16:21:17 2016
@@ -20,6 +20,7 @@
  */
 /*
  * Copyright (c) 2010, Oracle and/or its affiliates. All rights reserved.
+ * Copyright (c) 2016, Chris Fraire <cfraire@me.com>.
  */
 
 #ifndef _IPADM_IPMGMT_H
@@ -51,8 +52,8 @@
  * For more information on these definitions please refer to the top of
  * ipadm_persist.c. These are the name of the nvpairs which hold the
  * respective values. All nvpairs private to ipadm have names that begin
- * with "_". Note below that 'prefixlen' is an address property and therefore
- * not a private nvpair name.
+ * with "_". Note below that 'prefixlen' and 'reqhost' are address
+ * properties and therefore not a private nvpair name.
  */
 #define	IPADM_NVP_PROTONAME	"_protocol"	/* protocol name */
 #define	IPADM_NVP_IFNAME	"_ifname"	/* interface name */
@@ -63,6 +64,7 @@
 #define	IPADM_NVP_IPADDRHNAME	"_aname"	/* local hostname */
 #define	IPADM_NVP_IPDADDRHNAME	"_dname"	/* remote hostname */
 #define	IPADM_NVP_PREFIXLEN	"prefixlen"	/* prefixlen */
+#define	IPADM_NVP_REQHOST	"reqhost"	/* requested hostname */
 #define	IPADM_NVP_IPV6ADDR	"_ipv6addr"	/* name of IPv6 addr nvlist */
 #define	IPADM_NVP_DHCP		"_dhcp"		/* name of DHCP nvlist */
 #define	IPADM_NVP_WAIT		"_wait"		/* DHCP timeout value */
@@ -152,6 +154,21 @@
 #define	IPMGMT_APPEND	0x00000001
 #define	IPMGMT_REMOVE	0x00000002
 
+/*
+ * ipadm_addr_type_t-specific values that are cached in ipmgmtd and can
+ * make a round-trip back to client programs
+ */
+typedef union {
+	struct {
+		boolean_t		ipmgmt_linklocal;
+		struct sockaddr_in6		ipmgmt_ifid;
+	} ipmgmt_ipv6_cache_s;
+	struct {
+		boolean_t		ipmgmt_primary;
+		char			ipmgmt_reqhost[MAXNAMELEN];
+	} ipmgmt_dhcp_cache_s;
+} ipmgmt_addr_type_cache_u;
+
 /* IPMGMT_CMD_GETIF door_call argument structure */
 typedef struct ipmgmt_getif_arg_s {
 	ipmgmt_door_cmd_type_t	ia_cmd;
@@ -221,10 +238,15 @@
  *	- PERSIST updates the permanent data store
  *	- INIT	indicates that operation being performed is under init
  *		    context
+ *	- PROPS_ONLY indicates the update changes the running configuration of
+ *		    "props" data on the interface/address object. The props are
+ *		    cached there on the parent, so a PROPS_ONLY change does not
+ *		    affect the ACTIVE/PERSIST state of the parent.
  */
 #define	IPMGMT_ACTIVE		0x00000001
 #define	IPMGMT_PERSIST		0x00000002
 #define	IPMGMT_INIT		0x00000004
+#define	IPMGMT_PROPS_ONLY		0x00000008
 
 /* door call return value */
 typedef struct ipmgmt_retval_s {
@@ -260,9 +282,16 @@
 	sa_family_t		ir_family;
 	uint32_t		ir_flags;
 	ipadm_addr_type_t	ir_atype;
-	struct sockaddr_storage	ir_ifid;
+	ipmgmt_addr_type_cache_u	ir_atype_cache;
 } ipmgmt_aobjop_rval_t;
 
+#define	ipmgmt_ir_intfid	ir_atype_cache. \
+	ipmgmt_ipv6_cache_s.ipmgmt_ifid
+#define	ipmgmt_ir_primary	ir_atype_cache. \
+	ipmgmt_dhcp_cache_s.ipmgmt_primary
+#define	ipmgmt_ir_reqhost	ir_atype_cache. \
+	ipmgmt_dhcp_cache_s.ipmgmt_reqhost
+
 /* DB walk callback functions */
 typedef boolean_t	db_wfunc_t(void *, nvlist_t *, char *, size_t, int *);
 extern int		ipadm_rw_db(db_wfunc_t *, void *, const char *, mode_t,
--- old/usr/src/lib/libipadm/common/ipadm_ndpd.c	Mon Nov 14 16:21:17 2016
+++ new/usr/src/lib/libipadm/common/ipadm_ndpd.c	Mon Nov 14 16:21:17 2016
@@ -107,7 +107,7 @@
 	}
 
 	/* Persist the intfid. */
-	status = i_ipadm_addr_persist(iph, addr, B_FALSE, i_flags);
+	status = i_ipadm_addr_persist(iph, addr, B_FALSE, i_flags, NULL);
 	if (status != IPADM_SUCCESS) {
 		(void) i_ipadm_delete_addr(iph, addr);
 		(void) i_ipadm_send_ndpd_cmd(addr->ipadm_ifname, addr,
--- old/usr/src/lib/libipadm/common/libipadm.c	Mon Nov 14 16:21:17 2016
+++ new/usr/src/lib/libipadm/common/libipadm.c	Mon Nov 14 16:21:17 2016
@@ -22,6 +22,7 @@
 /*
  * Copyright (c) 2010, Oracle and/or its affiliates. All rights reserved.
  * Copyright 2014 Nexenta Systems, Inc.  All rights reserved.
+ * Copyright (c) 2016, Chris Fraire <cfraire@me.com>.
  */
 
 #include <stdio.h>
@@ -728,12 +729,13 @@
 		} else if (nvlist_lookup_string(nvl, IPADM_NVP_AOBJNAME,
 		    &aobjstr) == 0) {
 			/*
-			 * For a static address, we need to search for
-			 * the prefixlen in the nvlist `ifnvl'.
+			 * For addresses, we need to relocate addrprops from the
+			 * nvlist `ifnvl'.
 			 */
 			if (nvlist_exists(nvl, IPADM_NVP_IPV4ADDR) ||
-			    nvlist_exists(nvl, IPADM_NVP_IPV6ADDR)) {
-				status = i_ipadm_merge_prefixlen_from_nvl(ifnvl,
+			    nvlist_exists(nvl, IPADM_NVP_IPV6ADDR) ||
+			    nvlist_exists(nvl, IPADM_NVP_DHCP)) {
+				status = i_ipadm_merge_addrprops_from_nvl(ifnvl,
 				    nvl, aobjstr);
 				if (status != IPADM_SUCCESS)
 					continue;
@@ -955,4 +957,81 @@
 			err = EBADE;
 	}
 	return (err);
+}
+
+/*
+ * ipadm_is_nil_hostname() : Determine if the `hostname' is nil: i.e.,
+ *			NULL, empty, or a single space (e.g., as returned by
+ *			domainname(1M)/sysinfo).
+ *
+ *   input: const char *: the hostname to inspect;
+ *  output: boolean_t: B_TRUE if `hostname' is not NULL satisfies the
+ *			criteria above; otherwise, B_FALSE;
+ */
+
+boolean_t
+ipadm_is_nil_hostname(const char *hostname)
+{
+	return (hostname == NULL || *hostname == '\0'
+	    || (*hostname == ' ' && hostname[1] == '\0'));
+}
+
+/*
+ * ipadm_is_valid_hostname(): check whether a string is a valid hostname
+ *
+ *   input: const char *: the string to verify as a hostname
+ *  output: boolean_t: B_TRUE if the string is a valid hostname
+ *
+ * Note that we accept host names beginning with a digit, which is not
+ * strictly legal according to the RFCs but is in common practice, so we
+ * endeavour to not break what customers are using.
+ *
+ * RFC 1035 limits a wire-format domain name to 255 octets. For a printable
+ * `hostname' as we have, the limit is therefore 253 characters (excluding
+ * the terminating '\0'--or 254 characters if the last character of
+ * `hostname' is a '.'.
+ *
+ * Excerpt from section 2.3.1., Preferred name syntax:
+ *
+ * <domain> ::= <subdomain> | " "
+ * <subdomain> ::= <label> | <subdomain> "." <label>
+ * <label> ::= <letter> [ [ <ldh-str> ] <let-dig> ]
+ * <ldh-str> ::= <let-dig-hyp> | <let-dig-hyp> <ldh-str>
+ * <let-dig-hyp> ::= <let-dig> | "-"
+ * <let-dig> ::= <letter> | <digit>
+ */
+boolean_t
+ipadm_is_valid_hostname(const char *hostname)
+{
+	const size_t MAX_READABLE_NAME_LEN = 253;
+	char last_char;
+	size_t has_last_dot, namelen, i;
+
+	if (hostname == NULL)
+		return B_FALSE;
+
+	namelen = strlen(hostname);
+	if (namelen < 1)
+		return B_FALSE;
+
+	last_char = hostname[namelen - 1];
+	has_last_dot = last_char == '.';
+
+	if (namelen > MAX_READABLE_NAME_LEN + has_last_dot
+	    || last_char == '-')
+		return B_FALSE;
+
+	for (i = 0; hostname[i] != '\0'; i++) {
+		/*
+		 * As noted above, this deviates from RFC 1035 in that it allows a
+		 * leading digit.
+		 */
+		if (isalpha(hostname[i]) || isdigit(hostname[i]) ||
+		    (((hostname[i] == '-') || (hostname[i] == '.')) && (i > 0)))
+			continue;
+
+		return (B_FALSE);
+	}
+
+	return B_TRUE;
 }
--- old/usr/src/lib/libipadm/common/libipadm.h	Mon Nov 14 16:21:17 2016
+++ new/usr/src/lib/libipadm/common/libipadm.h	Mon Nov 14 16:21:17 2016
@@ -20,6 +20,7 @@
  */
 /*
  * Copyright (c) 2010, Oracle and/or its affiliates. All rights reserved.
+ * Copyright (c) 2016, Chris Fraire <cfraire@me.com>.
  */
 #ifndef _LIBIPADM_H
 #define	_LIBIPADM_H
@@ -29,6 +30,7 @@
 #endif
 
 #include <sys/types.h>
+#include <sys/param.h>
 #include <sys/socket.h>
 #include <net/if.h>
 #include <netdb.h>
@@ -101,7 +103,7 @@
  *  - IPADM_OPT_PERSIST:
  *	For all the create/delete/up/down/set/get functions,
  * 	requests to persist the configuration so that it can be
- *	re-enabled or reapplied on boot.
+ *	re-enabled or re-applied on boot.
  *
  *  - IPADM_OPT_ACTIVE:
  *	Requests to apply configuration without persisting it and
@@ -141,7 +143,17 @@
  *	Used to bring up a static address on creation
  *
  *  - IPADM_OPT_V46
- *      Used to plumb both IPv4 and IPv6 interfaces by ipadm_create_addr()
+ *	Used to plumb both IPv4 and IPv6 interfaces by ipadm_create_addr()
+ *
+ *  - IPADM_OPT_SET_PROPS
+ *	Used to indicate the update changes the running configuration of
+ *	"props" data on the object. The props are cached there on the parent,
+ *	but the PROPS_ONLY change does not affect the ACTIVE/PERSIST state of
+ *	the parent.
+ *
+ *  - IPADM_OPT_PERSIST_PROPS
+ *	Used when IPADM_OPT_SET_PROPS is active to indicate the update changes
+ *  the persistent configuration of the "props" data on the object.
  */
 #define	IPADM_OPT_PERSIST	0x00000001
 #define	IPADM_OPT_ACTIVE	0x00000002
@@ -157,6 +169,8 @@
 #define	IPADM_OPT_INFORM	0x00000800
 #define	IPADM_OPT_UP		0x00001000
 #define	IPADM_OPT_V46		0x00002000
+#define	IPADM_OPT_SET_PROPS	0x00004000
+#define	IPADM_OPT_PERSIST_PROPS		0x00008000
 
 /* IPADM property class */
 #define	IPADMPROP_CLASS_MODULE	0x00000001	/* on 'protocol' only */
@@ -257,7 +271,7 @@
 /* Check authorization for network configuration */
 extern boolean_t	ipadm_check_auth(void);
 /*
- * Interface mangement functions
+ * Interface management functions
  */
 extern ipadm_status_t	ipadm_create_if(ipadm_handle_t, char *, sa_family_t,
 			    uint32_t);
@@ -315,6 +329,7 @@
 /* Functions to set fields in addrobj for DHCP */
 extern ipadm_status_t	ipadm_set_primary(ipadm_addrobj_t, boolean_t);
 extern ipadm_status_t	ipadm_set_wait_time(ipadm_addrobj_t, int32_t);
+extern ipadm_status_t	ipadm_set_reqhost(ipadm_addrobj_t, const char *);
 
 /*
  * Property management functions
@@ -357,6 +372,8 @@
 			    uint_t, uint_t *);
 extern int		ipadm_new2legacy_propname(const char *, char *,
 			    uint_t, uint_t);
+extern boolean_t	ipadm_is_valid_hostname(const char *hostname);
+extern boolean_t	ipadm_is_nil_hostname(const char *hostname);
 
 #ifdef	__cplusplus
 }
--- old/usr/src/lib/libipadm/common/libipadm_impl.h	Mon Nov 14 16:21:17 2016
+++ new/usr/src/lib/libipadm/common/libipadm_impl.h	Mon Nov 14 16:21:17 2016
@@ -21,6 +21,7 @@
 /*
  * Copyright (c) 2010, Oracle and/or its affiliates. All rights reserved.
  * Copyright (c) 2013 by Delphix. All rights reserved.
+ * Copyright (c) 2016, Chris Fraire <cfraire@me.com>.
  */
 
 #ifndef _LIBIPADM_IMPL_H
@@ -87,6 +88,7 @@
 		struct {
 			boolean_t		ipadm_primary;
 			int32_t			ipadm_wait;
+			char			ipadm_reqhost[MAXNAMELEN];
 		} ipadm_dhcp_s;
 	} ipadm_addr_u;
 };
@@ -102,6 +104,7 @@
 #define	ipadm_stateful		ipadm_addr_u.ipadm_ipv6_intfid_s.ipadm_stateful
 #define	ipadm_primary		ipadm_addr_u.ipadm_dhcp_s.ipadm_primary
 #define	ipadm_wait		ipadm_addr_u.ipadm_dhcp_s.ipadm_wait
+#define	ipadm_reqhost	ipadm_addr_u.ipadm_dhcp_s.ipadm_reqhost
 
 /*
  * Data structures and callback functions related to property management
@@ -145,7 +148,7 @@
 			    nvlist_t *);
 extern ipadm_status_t	i_ipadm_init_addrobj(ipadm_handle_t, nvlist_t *);
 extern ipadm_status_t	i_ipadm_addr_persist(ipadm_handle_t,
-			    const ipadm_addrobj_t, boolean_t, uint32_t);
+			    const ipadm_addrobj_t, boolean_t, uint32_t, const char *);
 extern ipadm_status_t	i_ipadm_delete_addr(ipadm_handle_t, ipadm_addrobj_t);
 extern int		i_ipadm_strioctl(int, int, char *, int);
 extern boolean_t	i_ipadm_is_loopback(const char *);
@@ -185,7 +188,7 @@
 /* ipadm_addr.c */
 extern void		i_ipadm_init_addr(ipadm_addrobj_t, const char *,
 			    const char *, ipadm_addr_type_t);
-extern ipadm_status_t	i_ipadm_merge_prefixlen_from_nvl(nvlist_t *, nvlist_t *,
+extern ipadm_status_t	i_ipadm_merge_addrprops_from_nvl(nvlist_t *, nvlist_t *,
 			    const char *);
 extern ipadm_status_t	i_ipadm_get_addrobj(ipadm_handle_t, ipadm_addrobj_t);
 extern ipadm_status_t	i_ipadm_enable_static(ipadm_handle_t, const char *,
--- old/usr/src/lib/libipadm/common/mapfile-vers	Mon Nov 14 16:21:17 2016
+++ new/usr/src/lib/libipadm/common/mapfile-vers	Mon Nov 14 16:21:17 2016
@@ -20,6 +20,7 @@
 #
 #
 # Copyright (c) 2010, Oracle and/or its affiliates. All rights reserved.
+# Copyright (c) 2016, Chris Fraire <cfraire@me.com>.
 #
 
 #
@@ -67,6 +68,8 @@
 	ipadm_if_info;
 	ipadm_if_move;
 	ipadm_init_net_from_gz;
+	ipadm_is_nil_hostname;
+	ipadm_is_valid_hostname;
 	ipadm_legacy2new_propname;
 	ipadm_ndpd_read;
 	ipadm_ndpd_write;
@@ -80,6 +83,7 @@
 	ipadm_set_addr;
 	ipadm_set_addrprop;
 	ipadm_set_dst_addr;
+	ipadm_set_reqhost;
 	ipadm_set_ifprop;
 	ipadm_set_interface_id;
 	ipadm_set_primary;
--- old/usr/src/lib/libnwam/Makefile.com	Mon Nov 14 16:21:17 2016
+++ new/usr/src/lib/libnwam/Makefile.com	Mon Nov 14 16:21:17 2016
@@ -21,6 +21,7 @@
 #
 # Copyright 2010 Sun Microsystems, Inc.  All rights reserved.
 # Use is subject to license terms.
+# Copyright (c) 2016, Chris Fraire <cfraire@me.com>.
 #
 
 LIBRARY=	libnwam.a
@@ -43,7 +44,8 @@
 include ../../Makefile.rootfs
 
 LIBS =		$(DYNLIB) $(LINTLIB)
-LDLIBS +=	-lbsm -lc -ldladm -lnsl -lnvpair -lscf -lsecdb -lsocket
+LDLIBS +=	-lbsm -lc -ldladm -lnsl -lnvpair -lscf -lsecdb -lsocket \
+		-lipadm
 
 SRCDIR =	../common
 $(LINTLIB) := SRCS=	$(SRCDIR)/$(LINTSRC)
--- old/usr/src/lib/libnwam/common/libnwam.h	Mon Nov 14 16:21:17 2016
+++ new/usr/src/lib/libnwam/common/libnwam.h	Mon Nov 14 16:21:17 2016
@@ -20,6 +20,7 @@
  */
 /*
  * Copyright (c) 2008, 2010, Oracle and/or its affiliates. All rights reserved.
+ * Copyright (c) 2016, Chris Fraire <cfraire@me.com>.
  */
 
 /*
@@ -447,6 +448,8 @@
 #define	NWAM_NCU_PROP_IPV6_ADDRSRC		"ipv6-addrsrc"
 #define	NWAM_NCU_PROP_IPV6_ADDR			"ipv6-addr"
 #define	NWAM_NCU_PROP_IPV6_DEFAULT_ROUTE	"ipv6-default-route"
+#define	NWAM_NCU_PROP_IP_PRIMARY		"ip-primary"
+#define	NWAM_NCU_PROP_IP_REQHOST		"ip-reqhost"
 
 /* Some properties should only be set on creation */
 #define	NWAM_NCU_PROP_SETONCE(prop)	\
--- old/usr/src/lib/libnwam/common/libnwam_ncp.c	Mon Nov 14 16:21:18 2016
+++ new/usr/src/lib/libnwam/common/libnwam_ncp.c	Mon Nov 14 16:21:18 2016
@@ -22,6 +22,7 @@
 /*
  * Copyright 2010 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
+ * Copyright (c) 2016, Chris Fraire <cfraire@me.com>.
  */
 
 #include <assert.h>
@@ -39,6 +40,7 @@
 #include <strings.h>
 #include <unistd.h>
 #include <libdladm.h>
+#include <libipadm.h>
 
 #include "libnwam_impl.h"
 #include <libnwam_priv.h>
@@ -73,6 +75,7 @@
 static nwam_error_t valid_ip_version(nwam_value_t);
 static nwam_error_t valid_addrsrc_v4(nwam_value_t);
 static nwam_error_t valid_addrsrc_v6(nwam_value_t);
+static nwam_error_t valid_reqhost(nwam_value_t);
 
 struct nwam_prop_table_entry ncu_prop_table_entries[] = {
 	{NWAM_NCU_PROP_TYPE, NWAM_VALUE_TYPE_UINT64, B_FALSE, 1, 1, valid_type,
@@ -149,7 +152,16 @@
 	{NWAM_NCU_PROP_IPV6_DEFAULT_ROUTE, NWAM_VALUE_TYPE_STRING, B_FALSE, 0,
 	    1, nwam_valid_route_v6,
 	    "specifies per-interface default IPv6 route",
-	    NWAM_FLAG_NCU_TYPE_INTERFACE, NWAM_FLAG_NCU_CLASS_ALL_INTERFACE}
+	    NWAM_FLAG_NCU_TYPE_INTERFACE, NWAM_FLAG_NCU_CLASS_ALL_INTERFACE},
+	{NWAM_NCU_PROP_IP_PRIMARY, NWAM_VALUE_TYPE_BOOLEAN, B_FALSE, 0,
+	    1, nwam_valid_boolean,
+	    "specifies the status of an interface as primary for the delivery"
+	    " of client-wide configuration data",
+	    NWAM_FLAG_NCU_TYPE_INTERFACE, NWAM_FLAG_NCU_CLASS_ALL_INTERFACE},
+	{NWAM_NCU_PROP_IP_REQHOST, NWAM_VALUE_TYPE_STRING, B_FALSE, 0,
+	    1, valid_reqhost,
+	    "specifies a requested hostname for the interface",
+	    NWAM_FLAG_NCU_TYPE_INTERFACE, NWAM_FLAG_NCU_CLASS_ALL_INTERFACE},
 };
 
 #define	NWAM_NUM_NCU_PROPS	(sizeof (ncu_prop_table_entries) / \
@@ -1648,6 +1660,17 @@
 		return (NWAM_ENTITY_INVALID_VALUE);
 }
 
+static nwam_error_t
+valid_reqhost(nwam_value_t value)
+{
+	char *hostname;
+
+	if (nwam_value_get_string(value, &hostname) != NWAM_SUCCESS)
+		return (NWAM_ENTITY_INVALID_VALUE);
+	return (ipadm_is_valid_hostname(hostname) ? NWAM_SUCCESS
+	    : NWAM_ENTITY_INVALID_VALUE);
+}
+
 /* ARGSUSED0 */
 static nwam_error_t
 valid_link_mtu(nwam_value_t value)
--- old/usr/src/lib/libresolv2/common/mapfile-vers	Mon Nov 14 16:21:18 2016
+++ new/usr/src/lib/libresolv2/common/mapfile-vers	Mon Nov 14 16:21:18 2016
@@ -20,6 +20,7 @@
 #
 #
 # Copyright (c) 2004, 2010, Oracle and/or its affiliates. All rights reserved.
+# Copyright (c) 2016, Chris Fraire <cfraire@me.com>.
 #
 
 #
@@ -104,6 +105,7 @@
 	isc_puthexstring;
 	__log_close_debug_channels;
 	__memactive;
+	__ns_name_pton2;
 	p_sockun;
 	res_gethostbyname2;
 	res_getservers;
--- old/usr/src/man/man1m/dhcpagent.1m	Mon Nov 14 16:21:18 2016
+++ new/usr/src/man/man1m/dhcpagent.1m	Mon Nov 14 16:21:18 2016
@@ -1,9 +1,10 @@
 '\" te
 .\"  Copyright (c) 1992-1996 Competitive Automation, Inc. Copyright (c) 2009 Sun Microsystems, Inc. All Rights Reserved.
+.\"  Copyright (c) 2016, Chris Fraire <cfraire@me.com>.
 .\" The contents of this file are subject to the terms of the Common Development and Distribution License (the "License"). You may not use this file except in compliance with the License. You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE or http://www.opensolaris.org/os/licensing.
 .\" See the License for the specific language governing permissions and limitations under the License. When distributing Covered Code, include this CDDL HEADER in each file and include the License file at usr/src/OPENSOLARIS.LICENSE. If applicable, add the following below this CDDL HEADER, with the
 .\" fields enclosed by brackets "[]" replaced with your own identifying information: Portions Copyright [yyyy] [name of copyright owner]
-.TH DHCPAGENT 1M "Dec 11, 2015"
+.TH DHCPAGENT 1M "Nov 7, 2016"
 .SH NAME
 dhcpagent \- Dynamic Host Configuration Protocol (DHCP) client daemon
 .SH SYNOPSIS
@@ -15,7 +16,7 @@
 .SH DESCRIPTION
 .LP
 \fBdhcpagent\fR implements the client half of the Dynamic Host Configuration
-Protocol \fB(DHCP)\fR for machines running Solaris software.
+Protocol \fB(DHCP)\fR for machines running illumos software.
 .sp
 .LP
 The \fBdhcpagent\fR daemon obtains configuration parameters for the client
@@ -28,11 +29,12 @@
 powers down.
 .sp
 .LP
-For IPv4, the \fBdhcpagent\fR daemon is controlled through \fBifconfig\fR(1M)
-in much the same way that the \fBinit\fR(1M) daemon is controlled by
-\fBtelinit\fR(1M). \fBdhcpagent\fR can be invoked as a user process, albeit one
-requiring root privileges, but this is not necessary, as \fBifconfig\fR(1M)
-will start it automatically.
+For IPv4, the \fBdhcpagent\fR daemon is controlled through \fBipadm\fR(1M),
+\fBnwamcfg\fR(1M), or \fBifconfig\fR(1M) in much the same way that the
+\fBinit\fR(1M) daemon is controlled by \fBtelinit\fR(1M). \fBdhcpagent\fR can
+be invoked as a user process, albeit one requiring root privileges, but this is
+not necessary, as \fBipadm\fR(1M), \fBnwamcfg\fR(1M), or \fBifconfig\fR(1M)
+will start \fBdhcpagent\fR automatically.
 .sp
 .LP
 For IPv6, the \fBdhcpagent\fR daemon is invoked automatically by
@@ -41,16 +43,20 @@
 .sp
 .LP
 When invoked, \fBdhcpagent\fR enters a passive state while it awaits
-instructions from \fBifconfig\fR(1M) or \fBin.ndpd\fR(1M). When it receives a
-command to configure an interface, it brings up the interface (if necessary)
-and starts DHCP. Once DHCP is complete, \fBdhcpagent\fR can be queried for the
-values of the various network parameters. In addition, if DHCP was used to
-obtain a lease on an address for an interface, it configures the address for
-use. When a lease is obtained, it is automatically renewed as necessary. If the
+instructions from \fBipadm\fR(1M), \fBnwamcfg\fR(1M), \fBifconfig\fR(1M), or
+\fBin.ndpd\fR(1M). When \fBdhcpagent\fR receives a command to configure an
+interface, \fBdhcpagent\fR brings up the interface (if necessary) and starts
+DHCP. Once DHCP is complete, \fBdhcpagent\fR can be queried for the values of
+the various network parameters. In addition, if DHCP was used to obtain a lease
+on an address for an interface, \fBdhcpagent\fR configures the address for use.
+When a lease is obtained, it is automatically renewed as necessary. If the
 lease cannot be renewed, \fBdhcpagent\fR will unconfigure the address, but the
-interface will be left up and \fBdhcpagent\fR will attempt to acquire a new
-address lease. \fBdhcpagent\fR monitors system suspend/resume events and will
-validate any non-permanent leases with the DHCP server upon resume. Similarly,
+interface will be left up, and \fBdhcpagent\fR will attempt to acquire a new
+address lease.
+.sp
+.LP
+\fBdhcpagent\fR monitors system suspend/resume events and will validate any
+non-permanent leases with the DHCP server upon resume. Similarly,
 \fBdhcpagent\fR monitors link up/down events and will validate any
 non-permanent leases with the DHCP server when the downed link is brought back
 up. The lease validation mechanism will restart DHCP if the server indicates
@@ -102,10 +108,10 @@
 .sp
 .LP
 For IPv4, the \fBdhcpagent\fR daemon can be configured to request a particular
-host name. See the \fBREQUEST_HOSTNAME\fR description in the \fBFILES\fR
-section. When first configuring a client to request a host name, you must
-perform the following steps as root to ensure that the full DHCP negotiation
-takes place:
+Fully Qualified Domain Name (FQDN) or host name. See the \fBREQUEST_FQDN\fR or
+\fBREQUEST_HOSTNAME\fR description in the \fBFILES\fR section. When first
+configuring a client to request an FQDN or host name, you must perform the
+following steps as root to ensure that the full DHCP negotiation takes place:
 .sp
 .in +2
 .nf
@@ -494,9 +500,14 @@
 .ad
 .sp .6
 .RS 4n
-Contains persistent storage for DUID (DHCP Unique Identifier) and IAID
-(Identity Association Identifier) values. The format of these files is
-undocumented, and applications should not read from or write to them.
+Contains persistent storage for system-generated DUID (DHCP Unique Identifier)
+and interface-specific IAID (Identity Association Identifier) values which are
+used if no \fBCLIENT_ID\fR is defined (see below). The format of these files is
+undocumented, and applications should not read from or write to them.  Instead,
+\fBdhcpinfo\fR(1) can be used to query the \fBdhcpagent\fR for \fIClientID\fR.
+For DHCPv6 interfaces, the result will contain the DUID. For DHCPv4 interfaces
+with \fBV4_DEFAULT_IAID_DUID\fR enabled (see below), the result will contain
+the IAID and DUID.
 .RE
 
 .sp
@@ -536,6 +547,8 @@
 .sp
 Enabling this option is often desirable on mobile systems, such as laptops, to
 allow the system to recover quickly from moves.
+.sp
+Default value of this option is \fIno\fR.
 .RE
 
 .sp
@@ -545,9 +558,11 @@
 .ad
 .sp .6
 .RS 4n
-Indicates how long to wait between checking for valid \fBOFFER\fRs after
-sending a \fBDISCOVER\fR. For DHCPv6, sets the time to wait between checking
-for valid Advertisements after sending a Solicit.
+Indicates how long to wait in seconds between checking for valid
+\fBOFFER\fRs after sending a \fBDISCOVER\fR. For DHCPv6, sets the time to
+wait between checking for valid Advertisements after sending a Solicit.
+.sp
+Default value of this option is \fI3\fR.
 .RE
 
 .sp
@@ -630,6 +645,26 @@
 .sp
 .ne 2
 .na
+\fB\fBV4_DEFAULT_IAID_DUID\fR\fR
+.ad
+.sp .6
+.RS 4n
+Indicates whether to use, when CLIENT_ID is not defined, a system-managed,
+RFC 3315-style (i.e., DHCPv6-style) binding identifier as documented in
+RFC 4361, "Node-specific Client Identifiers for DHCPv4," for IPv4
+interfaces which for purposes of backward compatibility do not normally get
+default binding identifiers.
+.sp
+An IPv4 interface that is not in an IP network multipathing (IPMP) group,
+that is not IP over InfiniBand (IPoIB), and that is not a logical interface
+does not normally get a default binding identifier.
+.sp
+Default value of this option is \fIno\fR.
+.RE
+
+.sp
+.ne 2
+.na
 \fB\fBPARAM_REQUEST_LIST\fR\fR
 .ad
 .sp .6
@@ -658,6 +693,64 @@
 .sp
 .ne 2
 .na
+\fB\fBREQUEST_FQDN\fR\fR
+.ad
+.sp .6
+.RS 4n
+Indicates the client requests the DHCP server to map the client's leased
+IPv4 address to the Fully Qualified Domain Name (FQDN) associated with the
+network interface that performs DHCP on the client and to collaborate with
+a compatible DNS server to manage A and PTR resource records for the FQDN
+for the life of the lease.
+.sp .6
+The hostname in the FQDN is determined from the following possible
+configurations:
+.sp
+.ne 2
+.na
+1.  \fBipadm\fR(1M): include the \fB-1,--primary\fR flag when creating an
+address that uses DHCP so that \fBnodename\fR(4) is used as the
+\fIhostname\fR.
+.ad
+.sp
+.ne 2
+.na
+2.  \fBipadm\fR(1M): include the \fB-h,--reqhost\fR \fIhostname\fR switch
+when executing the \fBcreate-addr -T dhcp\fR subcommand, or use the
+\fBset-addrprop -p reqhost=\fR\fIhostname\fR subcommand for any existing
+DHCP address.
+.ad
+.sp
+.ne 2
+.na
+3.  \fBnwamcfg\fR(1M): set a property,
+\fBip-primary=\fR\fIon\fR, for an ncu ip that uses DHCP so that
+\fBnodename\fR(4) is used as the \fIhostname\fR.
+.ad
+.sp
+.ne 2
+.na
+4.  \fBnwamcfg\fR(1M): set a property,
+\fBip-reqhost=\fR\fIhostname\fR, for an ncu ip that uses DHCP.
+.ad
+.sp
+The \fIhostname\fR value is either a Partially Qualified Domain Name (PQDN)
+or an FQDN (i.e., a "rooted" domain name ending with a '.' or one inferred
+to be an FQDN if it contains at least three DNS labels such as
+srv.example.com).  If a PQDN is specified, then an FQDN is constructed if
+either a \fBdefaultdomain\fR(4) or a \fBresolv.conf\fR(4) \fBdomain\fR is
+defined.
+.sp
+If an FQDN is sent, \fBREQUEST_HOSTNAME\fR processing will not be done,
+per RFC 4702 (3.1):  "clients that send the Client FQDN option in their
+messages MUST NOT also send the Host Name."
+.sp
+Default value of this option is \fIyes\fR.
+.RE
+
+.sp
+.ne 2
+.na
 \fB\fBREQUEST_HOSTNAME\fR\fR
 .ad
 .sp .6
@@ -664,7 +757,8 @@
 .RS 4n
 Indicates the client requests the DHCP server to map the client's leased IPv4
 address to the host name associated with the network interface that performs
-DHCP on the client. The host name must be specified in the
+DHCP on the client. The host name must be specified as documented for a
+PQDN in \fBREQUEST_FQDN\fR above or specified in the
 \fB/etc/hostname.\fIinterface\fR\fR file for the relevant interface on a line
 of the form
 .sp
@@ -678,6 +772,8 @@
 where \fIhostname\fR is the host name requested.
 .sp
 This option works with DHCPv4 only.
+.sp
+Default value of this option is \fIyes\fR.
 .RE
 
 .RE
@@ -710,7 +806,9 @@
 .SH SEE ALSO
 .LP
 \fBdhcpinfo\fR(1), \fBifconfig\fR(1M), \fBinit\fR(1M), \fBin.mpathd\fR(1M),
-\fBin.ndpd\fR(1M), \fBsyslog\fR(3C), \fBattributes\fR(5), \fBdhcp\fR(5)
+\fBin.ndpd\fR(1M), \fBipadm\fR(1M), \fBnwamcfg\fR(1M), \fBsyslog\fR(3C),
+\fBdefaultdomain\fR(4), \fBnodename\fR(4), \fBresolv.conf\fR(4),
+\fBattributes\fR(5), \fBdhcp\fR(5)
 .sp
 .LP
 \fI\fR
--- old/usr/src/man/man1m/ipadm.1m	Mon Nov 14 16:21:18 2016
+++ new/usr/src/man/man1m/ipadm.1m	Mon Nov 14 16:21:18 2016
@@ -12,8 +12,9 @@
 .\" Copyright (c) 2012, Joyent, Inc. All Rights Reserved
 .\" Copyright (c) 2013 by Delphix. All rights reserved.
 .\" Copyright 2014 Nexenta Systems, Inc.  All rights reserved.
+.\" Copyright (c) 2016, Chris Fraire <cfraire@me.com>.
 .\"
-.Dd April 9, 2016
+.Dd November 7, 2016
 .Dt IPADM 1M
 .Os
 .Sh NAME
@@ -70,6 +71,8 @@
 .Op Fl t
 .Fl T Cm dhcp
 .Op Fl w Ar seconds Ns | Ns Cm forever
+.Op Fl 1
+.Op Fl h Ar hostname
 .Ar addrobj
 .Nm
 .Ic create-addr
@@ -411,6 +414,8 @@
 .Op Fl t
 .Fl T Cm dhcp
 .Op Fl w Ar seconds Ns | Ns Cm forever
+.Op Fl 1
+.Op Fl h Ar hostname
 .Ar addrobj
 .br
 .Nm
@@ -454,7 +459,30 @@
 Obtain the address via DHCP. This takes the following options:
 .Bl -tag -width ""
 .It Fl w Ns , Ns Fl -wait
-Specify the time, in seconds, that the command should wait to obtain an address.
+Specify the time, in seconds, that the command should wait to obtain an
+address; or specify
+.Cm forever
+to wait without interruption.  The default value is 120.
+.It Fl 1 Ns , Ns Fl -primary
+Specify that the interface is primary.  One effect will be that
+.Xr nodename 4
+will serve as
+.Fl h Ns , Ns Fl -reqhost
+if that switch is not otherwise specified.
+.It Fl h Ns , Ns Fl -reqhost
+Specify the host name to send to the DHCP server in order to request an
+association of a Fully Qualified Domain Name to the interface. An FQDN is
+determined from
+.Ar hostname
+if it is "rooted" (ending in a '.'), or if it consists of at least three
+DNS labels, or by appending to
+.Ar hostname
+the value configured separately using either
+.Xr defaultdomain 4
+or
+.Xr resolv.conf 4 .
+N.b. that the DHCP server implementation ultimately determines whether and
+how the client-sent FQDN is used.
 .El
 .It Fl T Cm addrconf
 Create an auto-configured address. This takes the following options:
@@ -631,14 +659,27 @@
 .Pq Cm on Ns / Ns Cm off .
 .It Cm prefixlen
 The number of bits in the IPv4 netmask or IPv6 prefix.
+.It Cm primary
+The DHCP primary interface flag (read-only).
 .It Cm private
 The address is not advertised to routing
 .Pq Cm on Ns / Ns Cm off .
+.It Cm reqhost
+The host name to send to the DHCP server in order to request an association
+of an FQDN to the interface.  For a primary DHCP interface,
+.Xr nodename 4
+is sent if this property is not defined.  See the
+.Nm
+.Ic create-addr
+.Fl T Cm dhcp
+subcommand for an explanation of how an FQDN is determined.
 .It Cm transmit
 Packets can be transmitted
 .Pq Cm on Ns / Ns Cm off .
 .It Cm zone
-The zone the addrobj is in.
+The zone the addrobj is in. (temporary-only.  Use
+.Xr zonecfg 1M
+to make persistent).
 .El
 .It Fl t Ns , Ns Fl -temporary
 Temporary, not persistent across reboots.
@@ -830,5 +871,8 @@
 .Xr ifconfig 1M ,
 .Xr ndd 1M ,
 .Xr zonecfg 1M ,
+.Xr defaultdomain 4 ,
+.Xr nodename 4 ,
 .Xr nsswitch.conf 4 ,
+.Xr resolv.conf 4 ,
 .Xr dhcp 5
--- old/usr/src/tools/scripts/onu.1onbld	Mon Nov 14 16:21:19 2016
+++ new/usr/src/tools/scripts/onu.1onbld	Mon Nov 14 16:21:19 2016
@@ -19,8 +19,9 @@
 .\" "
 .\" "Copyright (c) 2010, Oracle and/or its affiliates. All rights reserved.
 .\" "Copyright 2010, Richard Lowe
+.\" "Copyright (c) 2016, Chris Fraire <cfraire@me.com>.
 .\" "
-.TH ONU 1ONBLD "Aug 28, 2010"
+.TH ONU 1ONBLD "Nov 7, 2016"
 .SH NAME
 .I onu
 \- OS/Net Update
@@ -98,6 +99,12 @@
 One of the commands used by the script failed.
 .SH NOTES
 .LP
+Distributions which segment certain system directories onto separate, child
+datasets (e.g., /var for openindiana Text Install) must run
+.B beadm unmount <new beName>
+after running onu or else the child dataset will not mount at the correct
+location after reboot.
+.LP
 Former users of bfu should note the following ways in which onu behaves
 differently from bfu.  First, as noted above, onu creates a new BE, rather
 than updating an existing BE in-place.  Second, onu will not install packages
--- old/usr/src/uts/common/netinet/dhcp.h	Mon Nov 14 16:21:19 2016
+++ new/usr/src/uts/common/netinet/dhcp.h	Mon Nov 14 16:21:19 2016
@@ -22,6 +22,7 @@
 /*
  * Copyright 1996-2003 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
+ * Copyright (c) 2016, Chris Fraire <cfraire@me.com>.
  */
 
 /*
@@ -157,8 +158,15 @@
 
 #define	CD_SLPDA		78
 #define	CD_SLPSS		79
+#define	CD_CLIENTFQDN	81
 #define	CD_AGENTOPT		82
+
+/*
+ * Per RFC 3679, option 89 was "Never published as standard and [is] not in
+ * general use". See active CD_CLIENTFQDN and RFC 4702.
+ */
 #define	CD_FQDN			89
+
 #define	CD_PXEARCHi		93
 #define	CD_PXENIIi		94
 #define	CD_PXECID		95
